]> git.phdru.name Git - dotfiles.git/blob - .shellrc
Feat(recode-filenames-recursive): Allow to omit parameters
[dotfiles.git] / .shellrc
1 #
2 # $HOME/.shellrc
3 #
4
5 # ~/.bashrc: executed by bash(1) for non-login shells.
6 # see /usr/share/doc/bash/examples/startup-files (in the package bash-doc)
7 # for examples
8
9 # If not running interactively, don't do anything
10 case $- in
11     *i*) ;;
12       *) return ;;
13 esac
14
15 # Stop if non-interactive shell
16 [ -z "$PS1" ] && return
17
18 if test -n "$BASH_VERSION"; then
19    # append to the history file, don't overwrite it
20    shopt -s histappend
21
22    # check the window size after each command and, if necessary,
23    # update the values of LINES and COLUMNS.
24    shopt -s checkwinsize
25
26    # If set, the pattern "**" used in a pathname expansion context will
27    # match all files and zero or more directories and subdirectories.
28    #shopt -s globstar
29 fi
30
31
32 #if [ -x /usr/bin/dircolors ]; then
33 #   # I don't like these aliases - they work only in command line
34 #   # but not in scripts I run from command line.
35 #   # Color parameters must be passed via environment.
36 #   # So instead I put them in shell scripts in ~/bin.
37 #   alias ls='ls --color=auto'
38 #   alias dir='dir --color=auto'
39 #   alias vdir='vdir --color=auto'
40 #
41 #   alias grep='grep --color=auto'
42 #   alias fgrep='fgrep --color=auto'
43 #   alias egrep='egrep --color=auto'
44 #
45 #   alias dmesg='dmesg --human'
46 #fi
47
48
49 case "$HOME" in
50    /home/*)
51       if [ -L /home ]; then
52          START_DIR="`pwd`" &&
53          cd "$HOME" &&
54          HOME="`pwd`" &&
55          cd "$START_DIR"
56       fi
57    ;;
58 esac
59
60 if test -n "$BASH_VERSION"; then
61    [ "`type -t ls`" = alias ] && unalias ls
62    [ "`type -t ll`" = alias ] && unalias ll
63    [ "`type -t mc`" = alias ] && unalias mc
64
65    back() { cd - "$@"; }
66    functions() { typeset -f "$@"; }
67    j() { jobs; }
68
69    has_completion() { return 0; }
70    if [ -z "$BASH_COMPLETION_COMPAT_DIR" ]; then
71       if [ "$SHELL" = /bin/bash ]; then
72          if [ -d /usr/share/bash-completion -a -f /usr/share/bash-completion/bash_completion ]; then
73             . /usr/share/bash-completion/bash_completion
74             has_completion() { [ -r /usr/share/bash-completion/completions/$1 ]; }
75          elif [ -f /etc/bash_completion ]; then
76             . /etc/bash_completion
77             has_completion() { [ -r /etc/bash_completion.d/$1 ]; }
78          elif [ -d /etc/bash_completion.d ]; then
79             for _compf in /etc/bash_completion.d/*; do
80                . $_compf
81             done
82             has_completion() { [ -r /etc/bash_completion.d/$1 ]; }
83          fi
84       elif [ "$SHELL" = /usr/local/bin/bash ]; then
85          if [ -d /usr/local/etc/bash_completion.d ]; then
86             for _compf in /usr/local/etc/bash_completion.d/*; do
87                . $_compf
88             done
89             has_completion() { [ -r /usr/local/etc/bash_completion.d/$1 ]; }
90          fi
91       else
92          echo "Unknown OS type, cannot source bash_completion" >&2
93       fi
94    fi
95
96    for cmd in builtin cgmem_nice command dbus-launch exec \
97       killall man nice nohup pidof pidOf KillAll pgrep pkill psg pswg su sudo \
98       time whence whereis which xargs; do
99          ! has_completion $cmd && complete -o default -A command $cmd
100    done
101
102    for cmd in dig host mtr nslookup nc netcat nmap p ping ping6 socat \
103       telnet t tt \
104       tcptraceroute tcptraceroute6 tracert tracert6 traceroute traceroute6 \
105       whois wd wget wget-download wget-m wget-wrapper ww; do
106          ! has_completion $cmd && complete -A hostname $cmd
107    done
108
109    for cmd in distribute ftp lftp r rsync \
110       s scp ssh smbclient tcpdump tshark wireshark; do
111          ! has_completion $cmd && complete -o default -A hostname $cmd
112    done
113
114    if [ -d "$HOME"/.bash_completion.d ]; then
115       for _compf in "$HOME"/.bash_completion.d/*; do
116          . $_compf
117       done
118    fi
119
120    delegate_completion() {
121       local prog programs
122       prog=$1
123       if has_completion $prog; then
124          shift
125          programs="$@"
126          eval "_${prog}_completion_loader() {
127             _completion_loader $prog
128             complete -o nospace -F _$prog $programs
129             unset _${prog}_completion_loader
130             return 124
131          }"
132          complete -F _${prog}_completion_loader $programs
133       fi
134    }
135
136    delegate_completion make m
137    delegate_completion ping p
138    delegate_completion rsync r rsync_cgmn rsync_cgmn_recode
139    delegate_completion ssh s
140    delegate_completion wget wget-m wget-wrapper ww
141
142    unset has_completion delegate_completion
143
144    complete -A job bg fg j jobs wait
145    complete -A variable -A function unset
146
147    if [ -d "$HOME/lib/config" ]; then
148       complete -W "`cd \"$HOME/lib/config\" && echo *`" include
149    fi
150    complete -W "`echo $BROWSER | sed 's/:/ /g'`" start-browser
151
152    if [ "`type -t short_curdir`" != function -a \
153          -r "$HOME"/admin/prog/bash_prompt ]; then
154       . "$HOME"/admin/prog/bash_prompt
155    fi
156
157    #if type -p pip >/dev/null 2>&1; then
158    #   eval "`pip completion --bash`"
159    #   rm -rf /tmp/pip_build_"$USER"
160    #fi
161
162    #if which pyenv >/dev/null 2>&1; then
163    #   eval "`pyenv init -`"
164    #   eval "`pyenv virtualenv-init -`"
165    #fi
166
167    . virtualenvwrapper_lazy.sh 2>/dev/null
168
169    if [ -n "$VIRTUAL_ENV" ] && ! type deactivate >/dev/null 2>&1; then
170       . "$VIRTUAL_ENV/bin/activate"
171    fi
172
173    # Clean up python virtual environment on exit
174    # See https://virtualenvwrapper.readthedocs.io/en/latest/tips.html#clean-up-environments-on-exit
175
176    trap '[ "$VIRTUAL_ENV" ] && deactivate' EXIT
177
178 elif test -n "$KSH_VERSION" -o -n "$FCEDIT"; then
179    back() { cd - "$@"; }
180    j() { jobs; }
181 fi
182
183 PS1="$OPS1"
184
185 # clear screen and history, logout
186 chlo() { clear; cd; >$HISTFILE; unset HISTFILE; history -c; logout || exit; }
187
188
189 if test -x /usr/bin/git >/dev/null 2>&1; then
190    # chdir to a directory
191    cdgitpath() {
192       if [ $# -ne 1 ]; then
193          echo "Usage: cdgitpath path_key" >&2
194          return 1
195       fi
196
197       path_key="$1"
198       if [ -z "$path_key" ]; then
199          echo "Usage: cdgitpath path_key" >&2
200          return 1
201       fi
202
203       path_url="`git config --get --path $path_key`"
204       if echo "$path_url" | grep -q '^file:/'; then
205          path_url="`echo \"$path_url\" | sed 's@^file:/\+@/@'`"
206       fi
207       cd "$path_url"
208    }
209
210    # chdir to a remote's directory (if the remote is on the local FS)
211    cdremote() {
212       if [ $# -gt 1 ]; then
213          echo "Usage: cdremote [remote_name]" >&2
214          return 1
215       fi
216
217       if [ -z "$1" ]; then
218          branch="`git rev-parse --abbrev-ref HEAD`"
219          remote="`git config --get branch.$branch.remote`"
220       else
221          remote="$1"
222       fi
223
224       if [ -n "$remote" ] && git config --get remote.$remote.url |
225             grep -q '^\(file:/\|/\|\.\./\)'; then # (file:/ or / or ../ at the beginning)
226          cdgitpath remote.$remote.url
227       else
228
229          if [ -n "$1" ]; then
230             echo "Cannot find directory for remote $1" >&2
231             echo "Usage: cdremote [remote_name]" >&2
232             return 1
233          fi
234
235          if test -n "$BASH_VERSION"; then
236             _list_remotes '^\(file:/\|/\|\.\./\)' # (file:/ or / or ../ at the beginning)
237             if [ ${#GIT_REMOTES[*]} -eq 1 ]; then
238                remote=${GIT_REMOTES[0]}
239                unset GIT_REMOTES
240                cdgitpath remote.$remote.url
241             else
242                unset GIT_REMOTES
243                echo "Cannot find directory for any remote" >&2
244                echo "Usage: cdremote [remote_name]" >&2
245                return 1
246             fi
247          else
248             echo "Cannot find directory for remote $1" >&2
249             echo "Usage: cdremote [remote_name]" >&2
250             return 1
251          fi
252       fi
253    }
254
255    if test -n "$BASH_VERSION"; then
256       # completion for aliases in global .gitconfig
257
258       # fixup rbi rbia rbiap rbip - do refs name completion
259       _git_fixup() { __gitcomp_nl "$(__git_refs)" ; }
260       _git_rbi() { __gitcomp_nl "$(__git_refs)" ; }
261       _git_rbia() { __gitcomp_nl "$(__git_refs)" ; }
262       _git_rbiap() { __gitcomp_nl "$(__git_refs)" ; }
263       _git_rbip() { __gitcomp_nl "$(__git_refs)" ; }
264       #
265       # push-to-all-remotes - do branch name completion
266       _git_push_to_all_remotes() { __gitcomp_nl "$(__git_heads)" ; }
267
268       _cdgitpath_complete() {
269          local cur="${COMP_WORDS[COMP_CWORD]}"
270          COMPREPLY=(`compgen -W "$(__git_config_get_set_variables)" -- "$cur"`)
271       }
272
273       _git_open() {
274          _cdgitpath_complete
275       }
276
277       complete -F _cdgitpath_complete cdgitpath git-open
278
279       # list remotes with URLs matching a regexp
280       _list_remotes() {
281          if [ $# -ne 1 ]; then
282             echo "Usage: _list_remotes remote_regexp" >&2
283             return 1
284          fi
285          declare -ag GIT_REMOTES=()
286          local remote
287          for remote in `git remote`; do
288             if git config --get remote.$remote.url | grep -q "$1"; then
289                GIT_REMOTES+=($remote)
290             fi
291          done
292       }
293
294       # completion for cdremote and git-open-remote - list remotes with a pattern
295       _list_remotes_completion() {
296          local cur="${COMP_WORDS[COMP_CWORD]}"
297          _list_remotes "$1"
298          COMPREPLY=(`compgen -W "${GIT_REMOTES[*]}" -- "$cur"`)
299          unset GIT_REMOTES
300       }
301
302       # completion for cdremote - list remotes with directories as URLs
303       _cdremote_complete() {
304          _list_remotes_completion '^\(file:/\|/\|\.\./\)' # (file:/ or / or ../ at the beginning)
305          if [ ${#COMPREPLY[*]} -eq 0 ]; then
306             _list_remotes_completion .
307          fi
308       }
309
310       complete -F _cdremote_complete cdremote
311
312       # completion for git-open-remote - list remotes with http(s) URLs
313       _git_open_remote() {
314          _list_remotes_completion '^http\(s\)\?://'
315          if [ ${#COMPREPLY[*]} -eq 0 ]; then
316             _list_remotes_completion .
317          fi
318       }
319
320       complete -F _git_open_remote git-open-remote
321    fi
322 fi
323
324
325 include() {
326    cfg="$1"
327    if [ -f "./$cfg" -a -r "./$cfg" ]; then
328       echo "Reading config file \`$cfg'" 1>&2
329       . "./$cfg"
330    elif [ -f "$HOME/lib/config/$cfg" -a -r "$HOME/lib/config/$cfg" ]; then
331       echo "Reading config file \`$HOME/lib/config/$cfg'" 1>&2
332       . "$HOME/lib/config/$cfg"
333    else
334       echo "Cannot find config file \`$cfg'" 1>&2
335    fi
336 }
337
338
339 mc() {
340    if test -n "$BASH_VERSION"; then
341       MC_SAVE_OPS1="$OPS1"
342       if [ "`type -t short_curdir`" = function ]; then
343          OPS1="\`cgmem_which_prompt\`\u@\${HOSTNAME::5}:\`short_curdir\` "
344          OPS1+="\$(prompt_git)\\$\$SHLVL "
345       else
346          OPS1="\u@\h:\W \\$"
347       fi
348    fi
349
350    if [ -n "$SLOWTERM" ]; then
351       MC_SLOW="--slow"
352    fi
353
354    case "$TERM" in
355       screen*) # screen, screen.rxvt
356          MC_XTERM="-x"
357       ;;
358    esac
359
360    #TMPDIR="$HOME"/tmp
361    #export TMPDIR
362
363    MC_FOUND=NO
364
365    for wrapper in \
366          /usr/local/share/mc/bin/mc-wrapper.sh \
367          /usr/local/libexec/mc/mc-wrapper.sh \
368          /usr/share/mc/bin/mc-wrapper.sh; do
369       if [ -r $wrapper ]; then
370          . $wrapper $MC_SLOW $MC_XTERM "$@"
371          rc=$?
372          MC_FOUND=YES
373          break
374       fi
375    done
376
377    if [ $MC_FOUND = NO ]; then
378       for mc in /usr/local/bin/mc /usr/bin/mc; do
379          if [ -x $mc ]; then
380             MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER"
381             if [ ! -d MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER" ]; then
382                MC_TMP_DIR="${TMPDIR-/tmp}"
383             fi
384             MC_PWD_FILE="$MC_TMP_DIR/mc.pwd.$$"
385             mc_type="`mc_type.py $mc`"
386             if [ "$mc_type" = old ]; then
387                $mc -P $MC_SLOW $MC_XTERM "$@" > "$MC_PWD_FILE"
388             elif [ "$mc_type" = new ]; then
389                $mc -P "$MC_PWD_FILE" $MC_SLOW $MC_XTERM "$@"
390             else
391                continue
392             fi
393             rc=$?
394             MC_FOUND=YES
395             cd "`cat \"$MC_PWD_FILE\"`" && /bin/rm "$MC_PWD_FILE"
396             break
397          fi
398       done
399    fi
400
401    if [ $MC_FOUND = NO ]; then
402       echo "Cannot find mc-wrapper.sh or mc" >&2
403       rc=1
404    fi
405
406    [ -n "$MC_SAVE_OPS1" ] && OPS1="$MC_SAVE_OPS1"
407    unset MC_FOUND MC_PWD_FILE MC_SAVE_OPS1 MC_SLOW MC_TMP_DIR MC_XTERM
408
409    return $rc
410 }
411
412
413 mkcd() {
414    if [ $# -ne 1 ]; then
415       echo "Usage: mkcd directory_name" >&2
416    elif [ -d "$1" ]; then
417       cd "$1"
418    elif [ -e "$1" ]; then
419       echo "Error: $1 is a file" >&2
420    else
421       mkdir -p "$1" && cd "$1"
422    fi
423 }
424
425
426 if which tmux >/dev/null 2>&1; then
427    tmux() {
428       case "$TERM" in
429          rxvt)
430             TERM=rxvt-unicode command tmux "$@"
431          ;;
432
433          *)
434             command tmux "$@"
435          ;;
436       esac
437    }
438 fi
439
440
441 if [ "$SHLVL" -eq 1 ] && which startx >/dev/null 2>&1; then
442    X() { startx >> .Xserver.log 2>&1; cyr; rm -f .Xauthority; }
443 fi
444
445 x() { exit; }